From 90691f4ef2dc6e9b876bf8159023702b5938cc6d Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 15 2020 04:03:29 +0000
Subject: [PATCH 1388/2232] Add binding to append to CxxString


---

diff --git a/src/cxx.cc b/src/cxx.cc
index cbaecbf..1295d04 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -17,6 +17,11 @@ size_t cxxbridge05$cxx_string$length(const std::string &s) noexcept {
   return s.length();
 }
 
+void cxxbridge05$cxx_string$push(std::string &s, const uint8_t *ptr,
+                                 size_t len) noexcept {
+  s.append(reinterpret_cast<const char *>(ptr), len);
+}
+
 // rust::String
 void cxxbridge05$string$new(rust::String *self) noexcept;
 void cxxbridge05$string$clone(rust::String *self,
diff --git a/src/cxx_string.rs b/src/cxx_string.rs
index 7b47feb..dd53adc 100644
--- a/src/cxx_string.rs
+++ b/src/cxx_string.rs
@@ -6,9 +6,11 @@ use core::str::{self, Utf8Error};
 
 extern "C" {
     #[link_name = "cxxbridge05$cxx_string$data"]
-    fn string_data(_: &CxxString) -> *const u8;
+    fn string_data(this: &CxxString) -> *const u8;
     #[link_name = "cxxbridge05$cxx_string$length"]
-    fn string_length(_: &CxxString) -> usize;
+    fn string_length(this: &CxxString) -> usize;
+    #[link_name = "cxxbridge05$cxx_string$push"]
+    fn string_push(this: &mut CxxString, ptr: *const u8, len: usize);
 }
 
 /// Binding to C++ `std::string`.
@@ -82,6 +84,11 @@ impl CxxString {
     pub fn to_string_lossy(&self) -> Cow<str> {
         String::from_utf8_lossy(self.as_bytes())
     }
+
+    /// Appends a given string slice onto the end of this C++ string.
+    pub fn push_str(&mut self, s: &str) {
+        unsafe { string_push(self, s.as_ptr(), s.len()) }
+    }
 }
 
 impl Display for CxxString {

